---
title: SecurityPolicyViolationEvent.SecurityPolicyViolationEvent()
slug: Web/API/SecurityPolicyViolationEvent/SecurityPolicyViolationEvent
tags:
  - API
  - CSP
  - Constructor
  - Experimental
  - HTTP
  - Reference
  - Security
  - SecurityPolicyViolationEvent
---
<div>{{APIRef("{{HTTPSidebar}}")}}{{ SeeCompatTable() }}</div>

<p>The <code><strong>SecurityPolicyViolationEvent</strong></code> constructor creates a new <code>SecurityPolicyViolationEvent</code> object instance.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <var>SPVEvt</var> = <var>new SecurityPolicyViolationEvent(type, eventInitDict);</var></pre>

<h3 id="Properties">Properties</h3>

<dl>
 <dt>type</dt>
 <dd>A {{domxref("DOMString")}} representing the type of security policy violation that occurred.</dd>
 <dt>eventInitDict {{optional_inline}}</dt>
 <dd>A dictionary object containing information about the properties of the <code>SecurityPolicyViolationEvent</code> to be constructed. This can include the following properties, but bear in mind that if you do include an <code>eventInitDict</code>, certain properties must be included (marked below with <strong>required</strong>):
 <ul>
  <li><code>blockedURI</code>: The {{domxref("SecurityPolicyViolationEvent.blockedURI","blockedURI")}} of the <code>SecurityPolicyViolationEvent</code>. If not included, the default value is <code>""</code>.</li>
  <li><code>columnNumber</code>: The {{domxref("SecurityPolicyViolationEvent.columnNumber","columnNumber")}} of the <code>SecurityPolicyViolationEvent</code>. If not included, the default value is <code>0</code>.</li>
  <li><code>disposition</code>: The {{domxref("SecurityPolicyViolationEvent.disposition","disposition")}} of the <code>SecurityPolicyViolationEvent</code> (<strong>required</strong>).</li>
  <li><code>documentURI</code>: The {{domxref("SecurityPolicyViolationEvent.documentURI","documentURI")}} of the <code>SecurityPolicyViolationEvent</code> (<strong>required</strong>).</li>
  <li><code>effectiveDirective</code>: The {{domxref("SecurityPolicyViolationEvent.effectiveDirective","effectiveDirective")}} of the <code>SecurityPolicyViolationEvent</code> (<strong>required</strong>).</li>
  <li><code>lineNumber</code>: The {{domxref("SecurityPolicyViolationEvent.lineNumber","lineNumber")}} of the <code>SecurityPolicyViolationEvent</code>. If not included, the default value is <code>0</code>.</li>
  <li><code>originalPolicy</code>: The {{domxref("SecurityPolicyViolationEvent.originalPolicy","originalPolicy")}} of the <code>SecurityPolicyViolationEvent</code> (<strong>required</strong>).</li>
  <li><code>referrer</code>: The {{domxref("SecurityPolicyViolationEvent.referrer","referrer")}} of the <code>SecurityPolicyViolationEvent</code>. If not included, the default value is <code>""</code>.</li>
  <li><code>sample</code>: The {{domxref("SecurityPolicyViolationEvent.sample","sample")}} of the <code>SecurityPolicyViolationEvent</code>. If not included, the default value is <code>""</code>.</li>
  <li><code>sourceFile</code>: The {{domxref("SecurityPolicyViolationEvent.sourceFile","sourceFile")}} of the <code>SecurityPolicyViolationEvent</code>. If not included, the default value is <code>""</code>.</li>
  <li><code>statusCode</code>: The {{domxref("SecurityPolicyViolationEvent.statusCode","statusCode")}} of the <code>SecurityPolicyViolationEvent</code> (<strong>required</strong>).</li>
  <li><code>violatedDirective</code>: The {{domxref("SecurityPolicyViolationEvent.violatedDirective","violatedDirective")}} of the <code>SecurityPolicyViolationEvent</code> (<strong>required</strong>).</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A <code>SecurityPolicyViolationEvent</code> object instance.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">let SPVEvt = new SecurityPolicyViolationEvent('foo', {
  ...
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSP 3.0','#dom-securitypolicyviolationevent-securitypolicyviolationevent','SecurityPolicyViolationEvent')}}</td>
   <td>{{Spec2('CSP 3.0')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SecurityPolicyViolationEvent.SecurityPolicyViolationEvent")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTTP/CSP">Content Security Policy (CSP)</a></li>
</ul>
